#include <pragma/exec_lib.h>
#include <pragma/intuition_lib.h>
#include <dos/dos.h>
#include <exec/resident.h>

struct ClassBase:Library
{
BPTR sb_SegList;
IClass *cb_Class;
};

#pragma libbase ClassBase

extern "C"
{
IClass *ObtainClass(register __a6 ClassBase *cb);
}

extern "C" void abortLibInit();

extern APTR Dispatcher;

char LibNameString[]="pcd.datatype";
char LibVersionString[]="$VER:pcd.datatype 43.13 (22.01.00)  1997-2000 by Achim Stegemann\n";

Library *RenderBase;
Library *SuperClassBase;

static IClass *InitClass(register __a6 ClassBase *cb)
{
IClass *cl;
if(cl=MakeClass(LibNameString,"picture.datatype",0,0,0))
	{
	cl->h_Entry=&Dispatcher;
	cl->cl_UserData=ULONG(cb);
	AddClass(cl);
	}
return cl;
}

extern "C" void INIT_7_LibInit(register __a6 ClassBase *cb)
{
if(SuperClassBase=OpenLibrary("datatypes/picture.datatype",39))
	{
	if(RenderBase=OpenLibrary("render.library",30))
		{
		if(cb->cb_Class=cb->cb_Class=InitClass(cb)) return;
		}
	}
abortLibInit();
}

extern "C" void EXIT_7_LibInit(register __a6 ClassBase *cb)
{
if(cb->cb_Class) FreeClass(cb->cb_Class);
CloseLibrary(RenderBase);
CloseLibrary(SuperClassBase);
}

extern "C" IClass *ObtainClass(register __a6 ClassBase *cb)
{
return cb->cb_Class;
}

